package org.xbib.j2html.tags;

import java.io.IOException;
import java.io.InputStream;
import java.nio.charset.StandardCharsets;
import org.xbib.j2html.Config;
import static org.xbib.j2html.TagCreator.rawHtml;
import static org.xbib.j2html.TagCreator.script;
import static org.xbib.j2html.TagCreator.style;

public class InlineStaticResource {

    public static ContainerTag<? extends Tag<?>> get(InputStream inputStream, TargetFormat format) {
        try {
            String fileString = new String(inputStream.readAllBytes(), StandardCharsets.UTF_8);
            return switch (format) {
                case CSS_MIN -> style().with(rawHtml(Config.cssMinifier.minify(fileString)));
                case JS_MIN -> script().with(rawHtml(Config.jsMinifier.minify((fileString))));
                case CSS -> style().with(rawHtml(fileString));
                case JS -> script().with(rawHtml(fileString));
            };
        } catch (IOException e) {
            throw new RuntimeException(e);
        }
    }

    public enum TargetFormat {CSS_MIN, CSS, JS_MIN, JS}

}

